//	I2C-OLEDiRg[FSSD1306j `f
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
y|[gΉz	ATmega328P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	-	-	-	-	-	-	-	RST		OLEDZbg
portC	x	x	SCL	SDA	-	-	-	-		TWI(I2C)
portD	-	-	-	-	-	-	-	-		

yATmega328Pz
|CCCCCC---BBBBB|
|543210GRV54321|
>              |
|601234VG675670|
|CDDDDD--BBDDDB|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100010(62)
Low: 11100010 (E2)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111 (DF)
     |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----001 (F9)
          ||+-- BOOTRST f[^V[gQ
          ++-- BOOTSZ[1:0] f[^V[gQ

yrhz
Atmel Studio 6 (Version: 6.0.1996 - Service Pack 2)
AVR Toolchain 8 Bit / Version: 3.4.1.830 - GCC  4.6.2
ATmega328P 8MHzi8MHz/Ȃj	œKIvV: -Os
ATmega88P  8MHzi8MHz/Ȃj	œKIvV: -Os

yXVz
2013/10/23	v1.00		ATmega328P/ATmega88PœmFiLeʂATmega88Pł̎Qllj
	Program Memory Usage 	:	4118 bytes   50.3 % Full
	Data Memory Usage 		:	770 bytes   75.2 % Full
*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "SSD1306i2c.h"

//TWI(I2C)̃WX^ݒ肷
//TWBR = (F_CPU / scl - 16) / (2 * prescale)
//TWSR:TWPS1,0 = 00:1, 01:4, 10:16, 11:64
static	void	TWI_Init()
{
	//F_CPU=8MHzI2C=400kHz̐ݒ
	//TWBR = (8MHz / 400kHz - 16) / (2 * prescale) = 4 / (2 * 1) = 2, prescale=1
	TWBR = 2;
	TWSR = 0b00;
}

//܂Ot`߂̖ӖȒl
static	const uint8_t TemValue[] PROGMEM = { 5, 13, 10, 2, 8 };
static	const uint8_t HuValue[] PROGMEM = { 10, 5, 9, 6, 7 };

int	main(void)
{
	uint8_t	posX, posY, i;
	uint8_t	axisL, axisR, axisW, axisTemT, axisTemH, axisHuT, axisHuH, axisB;
	uint8_t	mLen, mGap;
	uint8_t	cx, cy, px, py;

	_delay_ms(100);	//dÏ҂
	
	TWI_Init();
	SSD1306I2C_Init(0);
	
	//o
	posY = 0;
	posX = FontW * 4;
	GR_DrawString(posX, posY, PSTR(""));

	ColorModeInverse();
	posX = FB_ScreenLeft + FBSizeWD - FontW * 4;
	GR_DrawString(posX, posY, PSTR(""));
	ColorModeNormal();

	//Ot̎
	axisL = FontW * 2;
	axisR = FB_ScreenLeft + FBSizeWD - FontW * 2;
	axisW = axisR - axisL;
	axisTemT = 0;
	axisTemH = FBSizeHD;
	axisB = axisTemT + axisTemH - 1;
	axisHuH = axisTemH * 1 / 5;
	axisHuT = axisB - axisHuH;

	FB_DrawLine(axisL, axisTemT, axisL, axisB);	//̏c
	FB_DrawLine(axisL, axisB, axisR, axisB);	//
	FB_FillRect(axisR, axisHuT, FontW * 2, axisHuH);	//Ȅc

	//Ot̖ڐ
	//̏c
	mLen= 3;
	mGap = axisTemH / 4;
	posX = axisL - FontW * 2;
	for (posY = axisTemT, i = 0; i < 4; i++, posY += mGap)
	{
		FB_DrawLine(axisL, posY, axisL + mLen, posY);
		FB_DrawChar(posX, posY, '0' + (4 - i));	//10̈(4,3,2,1)
		FB_DrawChar(posX + FontW, posY, '0');	//1̈(0)
	}
	GR_DrawString(posX, 0, PSTR("'C"));	//t[obt@ւ̕`ł͂Ȃ
	
	//
	mGap = axisW / 6;
	for (posX = axisL, i = 0; i < 6; i++, posX += mGap)
	{
		FB_DrawLine(posX, axisB - mLen, posX, axisB);
		if (0 < i) GR_DrawChar(posX, 7, '0' + i);	//t[obt@ւ̕`ł͂Ȃ
	}
	
	//Ȅc
	ColorModeInverse();
	mGap = axisHuH / 3;
	for (posY = axisHuT, i = 0; i < 3; i++, posY += mGap)
		FB_DrawLine(axisR, posY, axisR + mLen, posY);
	posX = axisR;
	posY = axisHuT - FontH;
	FB_DrawString(posX, posY, PSTR("60"));
	posY -= (FontH + 2);	//"60""%"̍sԂƂāu+2v
	FB_ClearRect(posX, posY, FontW * 2, FontH);	//]`撆Ȃ̂œ_FœhԂ
	FB_DrawChar(posX + FontW / 2, posY, '%');	//2ŃZ^Oʒu
	ColorModeNormal();

	//܂Ot
	mGap = axisW / 6;
	cx = cy = 0;
	for (posX = axisL + mGap, i = 0; i < 5; i++, posX += mGap)
	{
		px = cx;
		py = cy;
		cx = posX;
		cy = (axisTemT + 20) - pgm_read_byte(&TemValue[i]);
		if (i == 0) { px = cx; py = cy; }
		FB_DrawLine(px, py, cx, cy);
	}

	cx = cy = 0;
	for (posX = axisL + mGap, i = 0; i < 5; i++, posX += mGap)
	{
		px = cx;
		py = cy;
		cx = posX;
		cy = (axisHuT + 7) - pgm_read_byte(&HuValue[i]);
		if (i == 0) { px = cx; py = cy; }
		FB_DrawLine(px, py, cx, cy);
	}

	//yYꂸɁzt[obt@̓eʂɓ]
	FB_Update();

	return 0;
}
